%MACRO GE(DATA=,RESPONSE =Y,ALPHA=Z);
* Yield-stability index , Cotes, J. M., ustez, C. E., Martinez, R. and Estrada, N. 2002. 
American Journal of Potato Research 79:211-218.;

%PUT DATA=>>>&DATA<<<;
%PUT RESPONSE=>>>&RESPONSE<<<;
%PUT ALPHA=>>>&ALPHA<<<;
PROC SORT DATA=&DATA;
BY ENV;
PROC MIXED DATA=&DATA COVTEST INFO IC;
CLASS ENV GENOTYPE BLOCK;
MODEL &RESPONSE=GENOTYPE/DDFM = SATTERTH
OUTPRED=RES&RESPONSE(RENAME=(RESID=RES&RESPONSE));
RANDOM ENV BLOCK(ENV) ENV*GENOTYPE;
LSMEANS GENOTYPE/CL PDIFF=ALL ALPHA=&ALPHA;
MAKE 'DIFFS' OUT=DIFF;
MAKE 'LSMEANS' OUT=LSMEANS(RENAME=(ESTIMATE=_LSMEAN_));
MAKE 'COVPARMS' OUT=COV2;
TITLE 'ANALISIS DE VARIANZA COMBINADO POR SASMIXED';
PROC UNIVARIATE PLOT NORMAL DATA=RES&RESPONSE;
VAR RES&RESPONSE;
TITLE 'NORMALITY TEST FOR THE ERROR VARIANCE OF COMBINED ANOVA';
PROC MIXED DATA=&DATA COVTEST INFO IC;
CLASS GENOTYPE ENV BLOCK;
MODEL &RESPONSE=GENOTYPE/DDFM = SATTERTH;
RANDOM INT BLOCK/SUB=ENV;
RANDOM GENOTYPE/SUB=ENV GROUP=GENOTYPE;
MAKE 'COVPARMS' OUT=COV(RENAME=(ESTIMATE=SH_&RESPONSE STDERR=SE&RESPONSE));
TITLE 'SHUKLAS VARIANCE';
DATA COV2;
SET COV2;
IF NOT(COVPARM='Residual') THEN DELETE;
CME=ESTIMATE; DROP ESTIMATE;
PROC SORT DATA=LSMEANS; BY _LSMEAN_;
DATA R1;
SET LSMEANS;
_LSMEAN_=ROUND(_LSMEAN_,.00001);
Y=LAG(_LSMEAN_);

DATA RANGOS;
RANK&RESPONSE= 1;
LOOP: RANK&RESPONSE=RANK&RESPONSE;
SET R1;
IF Y='.' THEN Y=_LSMEAN_;
IF _LSMEAN_=Y THEN RANK&RESPONSE=RANK&RESPONSE;
ELSE RANK&RESPONSE=RANK&RESPONSE+ 1;OUTPUT;
GOTO LOOP;
PROC MEANS DATA=DIFF NWAY NOPRINT;
VAR DF STDERR;
OUTPUT OUT=DIFF MAX=DFMAX SEMX&RESPONSE
MIN=DFMIN SEMN&RESPONSE;
DATA KANG;
MERGE COV2 DIFF;
LOOP:SET RANGOS;
T=TINV((1-(&ALPHA/2)),DFMIN);
LSD=T*SEMX&RESPONSE;
OUTPUT; GOTO LOOP;
PROC MEANS DATA=KANG NWAY NOPRINT;
VAR _LSMEAN_;
OUTPUT OUT=S1 MEAN=_LSPROM_;
DATA LSD;
SET S1;
LOOP: SET KANG;
DIF=_LSMEAN_-_LSPROM_;
IF 9*LSD<ABS(DIF)<=10*LSD THEN RLSD&RESPONSE=10;
IF 8*LSD<ABS(DIF)<=9*LSD THEN RLSD&RESPONSE=9;
IF 7*LSD<ABS(DIF)<=8*LSD THEN RLSD&RESPONSE=8;
IF 6*LSD<ABS(DIF)<=7*LSD THEN RLSD&RESPONSE=7;
IF 5*LSD<ABS(DIF)<=6*LSD THEN RLSD&RESPONSE=6;
IF 4*LSD<ABS(DIF)<=5*LSD THEN RLSD&RESPONSE=5;
IF 3*LSD<ABS(DIF)<=4*LSD THEN RLSD&RESPONSE=4;
IF 2*LSD<ABS(DIF)<=3*LSD THEN RLSD&RESPONSE=3;
IF LSD<ABS(DIF)<=2*LSD THEN RLSD&RESPONSE=2;
IF ABS(DIF)<=I_SD THEN RLSD&RESPONSE=I;
IF DIP<0 THEN RLSD&RESPONSE=RLSD&RESPONSE*(-1);
IS&RESPONSE=RANK&RESPONSE+RLSD&RESPONSE;
OUTPUT; GOTO LOOP;
DATA COV;
SET COV;
IF COVPARM='Intercept' THEN DELETE;
IF COVPARM='BLOCK' THEN DELETE;
IF COVPARM='block' THEN DELETE;
IF COVPARM='Residual' THEN DELETE;
IF SE&RESPONSE='.' THEN SE&RESPONSE=0;
DATA STAB;
MERGE COV;
IF ProbZ>0.10 THEN S&RESPONSE=0;
IF 0.05<ProbZ<=0.10 THEN S&RESPONSE=-2;
IF 0.01<ProbZ<=0.05 THEN S&RESPONSE=-4;
IF ProbZ<=0.01 THEN S&RESPONSE=-8;
IF ProbZ='.' THEN S&RESPONSE=0;
IF ProbZ='.' THEN ProbZ=l;
PROC SORT DATA=LSD;
BY GENOTYPE;
*PROC SORT DATA=STAB; 
*BY GROUP;
DATA YS;
MERGE LSD STAB;
YS&RESPONSE=IS&RESPONSE+S&RESPONSE;
PROC MEANS DATA=YS NWAY NOPRINT;
VAR YS&RESPONSE;
OUTPUT OUT=YS1 MEAN=MYS&RESPONSE;
DATA YS&RESPONSE(RENAME=(_LSMEAN_=MEAN&RESPONSE));
SET YS1;
LOOP: SET YS;
IF YS&RESPONSE>MYS&RESPONSE THEN SELC&RESPONSE='SI'; ELSE SELC&RESPONSE='NO';
OUTPUT; GOTO LOOP;
PROC SORT; BY MEAN&RESPONSE;
PROC PRINT;
VAR GROUP GENOTYPE MEAN&RESPONSE
RANK&RESPONSE RLSD&RESPONSE IS&RESPONSE
SH_&RESPONSE
SE&RESPONSE S&RESPONSE YS&RESPONSE
SELC&RESPONSE;
TITLE 'YIELD-STABILITY INDEX FOR EACH GENOTYPE';
PROC MEANS DATA=YS&RESPONSE NWAY NOPRINT;
VAR T DFMIN SEMX&RESPONSE LSD MYS&RESPONSE
_LSPROM_;
OUTPUT OUT=PARMS MEAN=T DFMIN
SEMX&RESPONSE LSD MYS&RESPONSE LSPROM ;
PROC PRINT;
TITLE 'MEANS FOR OBTAIN YIELD-STABILITY INDEX';
PROC SORT DATA=YS&RESPONSE;
BY GENOTYPE;
%MEND GE;
